#include "config.h"
#ifdef HAVE_LIBFCGI
/* DO NOT #include <stdio.h> */
#include <fcgi_stdio.h>
#else
#include <stdio.h>
#endif
#include <stdlib.h>
#include <time.h>

int debugfd=2;

void
timestamp()
{
  time_t t;
  time(&t);
  printf("%s\n", ctime(&t));
  return;
}

main(argc, argv)
     int argc;
     char *argv[];
{
  int i;
  char *initstr;
#ifdef HAVE_LIBCLIENT		/* OCI client library */
  extern unsigned long usec_oopen, usec_oparse, usec_odescr, usec_odefin,
    usec_oexec, usec_ofetch, usec_brl_oci_writestring;

  srand(time(0));
  timestamp();
  initstr=getenv("OCIINIT");
  if (initstr)
    {
      printf("Initializing...");
      printf("%05d\n", brl_oci_init(initstr));
    }

  printf("Parsing...\n");
  for(i=2; i < argc; i++)
    {
      timestamp();
      brl_oci_dosql(argv[1], argv[i], stdout);
    }

  timestamp();

  printf("oopen: %9ld\noparse:%9ld\nodescr:%9ld\nodefin:%9ld\noexec: %9ld\nofetch:%9ld\nwrites:%9ld\n",
	 usec_oopen, usec_oparse, usec_odescr, usec_odefin,
	 usec_oexec, usec_ofetch, usec_brl_oci_writestring);
  exit(0);
#else
  fprintf(stderr, "%s: Not compiled with OCI.\n", argv[0]);
  exit(1);
#endif
}
