(load-option 'hash-table)

;;;
;;; brl-restrict-symlist
;;;  contains symbols for procedures which untrusted code must not apply
;;;   - file manipulation
;;;   - mutation like set! (subsequent code might break if global env changed)
;;;   - opening X displays or other network connections
;;;   - Unix shell commands
;;;

(define brl-restrict-symlist
  '(%exit
    %quit
    abort
    abort->nearest
    abort->previous
    abort->top-level
    add-event-receiver!
    add-gc-daemon!
    add-gc-daemon!/no-restore
    add-identification!
    add-secondary-gc-daemon!
    add-system!
    add-to-population!
    add-to-select-registry!
    add-unparser-special-object!
    add-unparser-special-pair!
    append!
    append-map!
    append-map*!
    apply
    bit-string-and!
    bit-string-andc!
    bit-string-clear!
    bit-string-fill!
    bit-string-move!
    bit-string-movec!
    bit-string-or!
    bit-string-set!
    bit-string-xor!
    brl-cgi-request
    brl-environment-put!
    brl-filter-result
    brl-query-read
    brl-query-read-name
    brl-query-read-value
    brl-sql-env
    brl-sql-eval-string
    brl-sql-update
    brl-unix-output
    cache-console-channel-descriptor!
    cd
    close-all-open-files
    close-input-port
    close-output-port
    close-port
    close-tcp-server-socket
    copy-file
    copy-program
    del-assoc!
    del-assq!
    del-assv!
    delete!
    delete-directory
    delete-environment-variable!
    delete-file
    delete-file-no-errors
    dequeue!
    dequeue!/unsafe
    directory-channel-open
    disk-restore
    disk-save
    enable-interrupts!
    enqueue!
    enqueue!/unsafe
    environment-assign!
    eval
    event-distributor/invoke!
    except-last-pair!
    exit
    exit-advice
    exit-current-thread
    file-access
    file-access-time
    file-access-time-direct
    file-access-time-indirect
    file-attributes
    file-attributes-direct
    file-attributes-indirect
    file-attributes/access-time
    file-attributes/change-time
    file-attributes/gid
    file-attributes/inode-number
    file-attributes/length
    file-attributes/mode-string
    file-attributes/modification-time
    file-attributes/n-links
    file-attributes/type
    file-attributes/uid
    file-directory?
    file-exists?
    file-length
    file-modes
    file-modification-time
    file-modification-time-direct
    file-modification-time-indirect
    file-namestring
    file-open-append-channel
    file-open-input-channel
    file-open-io-channel
    file-open-output-channel
    file-pathname
    file-position
    file-readable?
    file-set-position
    file-symbolic-link?
    file-touch
    file-writable?
    flo:vector-set!
    flush-purification-queue!
    for-each-system!
    ge
    hash-table/clean!
    hash-table/clear!
    hash-table/put!
    hash-table/remove!
    hash-table/set-entry-datum!
    hash-table/set-entry-value!
    initialize-system-primitives!
    invoke-restart
    invoke-restart-interactively
    load
    load-latest
    load-noisily
    load-option
    load-system!
    load/default-find-pathname-with-type
    load/default-types
    load/purification-root
    load/push-hook!
    make-directory
    make-generic-i/o-port
    make-generic-input-port
    make-generic-output-port
    make-graphics-device
    make-graphics-device-type
    make-i/o-port
    make-input-port
    make-output-port
    make-pipe
    make-subprocess
    make-system
    make-the-environment
    map-over-population!
    named-structure/set-tag-description!
    open-binary-i/o-file
    open-binary-input-file
    open-binary-output-file
    open-i/o-file
    open-input-file
    open-output-file
    open-pty-master
    open-tcp-server-socket
    open-tcp-stream-socket
    open-unix-stream-socket
    package/add-child!
    parser-table/set-entry!
    port/set-input-blocking-mode
    port/set-input-terminal-mode
    port/set-output-blocking-mode
    port/set-output-terminal-mode
    port/with-input-blocking-mode
    port/with-input-terminal-mode
    port/with-output-blocking-mode
    port/with-output-terminal-mode
    pty-master-continue
    pty-master-hangup
    pty-master-interrupt
    pty-master-kill
    pty-master-quit
    pty-master-send-signal
    pty-master-stop
    quit
    read-bits!
    remove-event-receiver!
    remove-from-population!
    remove-from-select-registry!
    rename-file
    repl-history/record!
    reset-environment-variables!
    restart
    restart/put!
    reverse!
    scode-eval
    set!
    set-apply-hook-extra!
    set-apply-hook-procedure!
    set-car!
    set-cdr!
    set-cell-contents!
    set-cmdl/state!
    set-command-line-parser!
    set-comment-expression!
    set-comment-text!
    set-compiled-code-block/debugging-info!
    set-console-i/o-port!
    set-current-input-port!
    set-current-output-port!
    set-current-parser-table!
    set-declaration-expression!
    set-declaration-text!
    set-entity-extra!
    set-entity-procedure!
    set-environment-extension-parent!
    set-environment-variable!
    set-environment-variable-default!
    set-file-modes!
    set-file-times!
    set-gc-safety-margin!
    set-hash-table/rehash-size!
    set-hash-table/rehash-threshold!
    set-input-port/state!
    set-interaction-i/o-port!
    set-interrupt-enables!
    set-lambda-body!
    set-notification-output-port!
    set-nt-select-registry/console!
    set-nt-select-registry/descriptors!
    set-output-port/state!
    set-port/state!
    set-record-type-application-method!
    set-record-type-method!
    set-record-type-unparser-method!
    set-repl/environment!
    set-repl/printer-history!
    set-repl/prompt!
    set-repl/reader-history!
    set-repl/syntax-table!
    set-string-length!
    set-system/modification!
    set-system/version!
    set-terminal-input-baud-rate!
    set-terminal-output-baud-rate!
    set-thread-timer-interval!
    set-trace-output-port!
    set-working-directory-pathname!
    signal-breakpoint
    signal-condition
    signal-thread-event
    sort!
    sql
    start-batch-subprocess
    start-pipe-subprocess
    start-pty-subprocess
    start-subprocess-in-background
    start-thread-timer
    stop-current-thread
    stop-thread-timer
    string-capitalize!
    string-downcase!
    string-fill!
    string-replace!
    string-set!
    string-upcase!
    subprocess-kill
    substring-capitalize!
    substring-downcase!
    substring-fill!
    substring-move-left!
    substring-move-right!
    substring-replace!
    substring-upcase!
    subvector-fill!
    subvector-move-left!
    subvector-move-right!
    system-hunk3-set-cxr0!
    system-hunk3-set-cxr1!
    system-hunk3-set-cxr2!
    tcp-server-connection-accept
    terminal-set-state
    toggle-gc-notification!
    trigger-secondary-gc-daemons!
    unix/file-access
    unix/file-time->string
    unix/system
    unix/uid->string
    unix/user-home-directory
    unparser-table/set-entry!
    unparser/set-tagged-pair-method!
    unparser/set-tagged-vector-method!
    vector-8b-fill!
    vector-8b-set!
    vector-fill!
    vector-set!
    weak-delq!
    weak-set-car!
    weak-set-cdr!
    with-gc-notification!
    with-input-from-binary-file
    with-input-from-file
    with-input-from-port
    with-interaction-i/o-port
    with-output-to-binary-file
    with-output-to-file
    with-output-to-port
    with-trace-output-port
    without-interrupts
    wt-tree/add!
    wt-tree/delete!
    wt-tree/delete-min!
    x-close-all-displays
    x-graphics/open-display))

(define brl-restrict-symhash
  (let* ((table (make-eq-hash-table (length brl-restrict-symlist)))
	 (brl-put! (lambda (key) (hash-table/put! table key #t))))
    (map brl-put! brl-restrict-symlist)
    table))

(define (brl-restricted-symbol? sym)
  (if (hash-table/get brl-restrict-symhash sym #f)
      sym
      #f))

;;;
;;; (brl-restricted-object? obj)
;;; returns #t if obj from untrusted source should not be passed to eval
;;;

; Really only need to restrict objects that might be applied.

(define (brl-restricted-for-apply? obj)
  (cond ((symbol? obj) (brl-restricted-symbol? obj))
	(else (brl-restricted-object? obj))))

; Let people use restricted symbols as variable names for CGI input, etc.
; e.g. load

(define (brl-restricted-arglist? arglist)
  (cond ((not (pair? arglist)) #f)	; handle '(), etc.
	(else (or (brl-restricted-object? (car arglist))
		  (brl-restricted-arglist? (cdr arglist))))))

; As long as eval and apply are restricted, the following will work,
; Although it will needlessly restrict some constructs
; e.g. (let ((load "hi")) (display load))
; This would be restricted because it looks like 'load is applied.

(define (brl-restricted-object? obj)
  (cond ((pair? obj) (or (brl-restricted-for-apply? (car obj))
			 (brl-restricted-arglist? (cdr obj))))
	(else #f)))

(define (brl-eval-untrusted code env)
  (let ((restriction (brl-restricted-object? code)))
    (cond (restriction
	   (error "Restricted symbol -" restriction
		  (error-irritant/noise " - found in untrusted code")
		  code))
	  (else (eval code env)))))
