;;;
;;; Syntactic Sugar to make BRL sweeter to the novice
;;;

(define silent brl-silent)

(define brl-syntax-table system-global-syntax-table)

;; [(html foo)]
;;  is sweeter than
;; [(brl-html-encode-env foo (the-environment))]
;; environment is used to get brl-null-value

(syntax-table-define brl-syntax-table 'html
  (macro (obj) (list 'brl-html-encode-env obj '(the-environment))))

;; [(html-repeat table)]
;;  is sweeter than
;; [(brl-html-repeat-env table (the-environment))]
;; environment is used as parent env for table if none defined

(syntax-table-define brl-syntax-table 'html-repeat
  (macro (obj) (list 'brl-html-repeat-env obj '(the-environment))))

;; [(sql expr)]
;;  is sweeter than
;; [(brl-sql-env expr (the-environment))]
;; environment is used to define parent env if sql result is a table

(syntax-table-define brl-syntax-table 'sql
  (macro x (list 'brl-sql-env (cons 'list x) '(the-environment))))

;; [(html-mail)]
;;  is sweeter than
;; [(brl-html-mail-env (the-environment))]
;; environment is used for brl-filter of mail body

(syntax-table-define brl-syntax-table 'html-mail
  (macro () (list 'brl-html-mail-env '(the-environment))))

;; [(getenv PATH)]
;;  is sweeter than
;; [(brl-lookup 'PATH cgi-environment)]

(syntax-table-define brl-syntax-table 'getenv
  (macro (sym) (list 'brl-lookup (list 'quote sym) 'cgi-environment)))
